    All Packages  Class Hierarchy  This Package  Previous  Next  Index

# Class java.lang.Runtime

    java.lang.Object
       |
       +----java.lang.Runtime

public class Runtime
extends Object

##

exec(String)
  Executes the specified string command in a separate process.
exec(String, String[])
  Executes the specified string command in a separate process with the specified environment.
exec(String[])
  Executes the specified command and arguments in a separate process.
exec(String[], String[])
  Executes the specified command and arguments in a separate process with the specified environment.
exit(int)
  Terminates the currently running Java Virtual Machine.
freeMemory()
  Returns the amount of free memory in the system.
gc()
  Runs the garbage collector.
getLocalizedInputStream(InputStream)
  Creates a localized version of an input stream. Deprecated.
getLocalizedOutputStream(OutputStream)
  Creates a localized version of an output stream. Deprecated.
getRuntime()
  Returns the runtime object associated with the current Java application.
load(String)
  Loads the specified filename as a dynamic library.
loadLibrary(String)
  Loads the dynamic library with the specified library name.
runFinalization()
  Runs the finalization methods of any objects pending finalization.
runFinalizersOnExit(boolean)
  Enable or disable finalization on exit; doing so specifies that the finalizers of all objects that have finalizers that have not yet been automatically invoked are to be run before the Java runtime exits.
totalMemory()
  Returns the total amount of memory in the Java Virtual Machine.
traceInstructions(boolean)
  Enables/Disables tracing of instructions.
traceMethodCalls(boolean)
  Enables/Disables tracing of method calls.

##

getRuntime

     public static Runtime getRuntime()

  Returns the runtime object associated with the current Java application.

  Returns:
    the `Runtime` object associated with the current Java application.

exit

     public void exit(int status)

  Terminates the currently running Java Virtual Machine. This method never returns normally.

  If there is a security manager, its `checkExit` method is called with the status as its argument. This may result in a security exception.

  The argument serves as a status code; by convention, a nonzero status code indicates abnormal termination.

  Parameters:
    status - exit status.
  Throws: SecurityException
    if the current thread cannot exit with the specified status.
  See Also:
    SecurityException, checkExit

runFinalizersOnExit

     public static void runFinalizersOnExit(boolean value)

  Enable or disable finalization on exit; doing so specifies that the finalizers of all objects that have finalizers that have not yet been automatically invoked are to be run before the Java runtime exits. By default, finalization on exit is disabled. An invocation of the runFinalizersOnExit method is permitted only if the caller is allowed to exit, and is otherwise rejected by the security manager.

  See Also:
    gc, exit

exec

     public Process exec(String command) throws IOException

  Executes the specified string command in a separate process.

  The `command` argument is parsed into tokens and then executed as a command in a separate process. This method has exactly the same effect as `exec(command, null)`.

  Parameters:
    command - a specified system command.
  Returns:
    a `Process` object for managing the subprocess.
  Throws: SecurityException
    if the current thread cannot create a subprocess.
  See Also:
    exec

exec

     public Process exec(String command,
                         String envp[]) throws IOException

  Executes the specified string command in a separate process with the specified environment.

  This method breaks the `command` string into tokens and creates a new array `cmdarray` containing the tokens; it then performs the call `exec(cmdarray, envp)`.

  Parameters:
    command - a specified system command.
    envp - array containing environment in format name=value
  Returns:
    a `Process` object for managing the subprocess.
  Throws: SecurityException
    if the current thread cannot create a subprocess.
  See Also:
    exec

exec

     public Process exec(String cmdarray[]) throws IOException

  Executes the specified command and arguments in a separate process.

  The command specified by the tokens in `cmdarray` is executed as a command in a separate process. This has exactly the same effect as `exec(cmdarray, null)`.

  Parameters:
    cmdarray - array containing the command to call and its arguments.
  Returns:
    a `Process` object for managing the subprocess.
  Throws: SecurityException
    if the current thread cannot create a subprocess.
  See Also:
    exec

exec

     public Process exec(String cmdarray[],
                         String envp[]) throws IOException

  Executes the specified command and arguments in a separate process with the specified environment.

  If there is a security manager, its `checkExec` method is called with the first component of the array `cmdarray` as its argument. This may result in a security exception.

  Given an array of strings `cmdarray`, representing the tokens of a command line, and an array of strings `envp`, representing an "environment" that defines system properties, this method creates a new process in which to execute the specified command.

  Parameters:
    cmdarray - array containing the command to call and its arguments.
    envp - array containing environment in format name=value.
  Returns:
    a `Process` object for managing the subprocess.
  Throws: SecurityException
    if the current thread cannot create a subprocess.
  See Also:
    SecurityException, checkExec

freeMemory

     public native long freeMemory()

  Returns the amount of free memory in the system. The value returned by this method is always less than the value returned by the `totalMemory` method. Calling the `gc` method may result in increasing the value returned by `freeMemory.`

  Returns:
    an approximation to the total amount of memory currently available for future allocated objects, measured in bytes.

totalMemory

     public native long totalMemory()

  Returns the total amount of memory in the Java Virtual Machine.

  Returns:
    the total amount of memory currently available for allocating objects, measured in bytes.

gc

     public native void gc()

  Runs the garbage collector. Calling this method suggests that the Java Virtual Machine expend effort toward recycling unused objects in order to make the memory they currently occupy available for quick reuse. When control returns from the method call, the Java Virtual Machine has made its best effort to recycle all unused objects.

  The name `gc` stands for "garbage collector". The Java Virtual Machine performs this recycling process automatically as needed even if the `gc` method is not invoked explicitly.

runFinalization

     public native void runFinalization()

  Runs the finalization methods of any objects pending finalization. Calling this method suggests that the Java Virtual Machine expend effort toward running the `finalize` methods of objects that have been found to be discarded but whose `finalize` methods have not yet been run. When control returns from the method call, the Java Virtual Machine has made a best effort to complete all outstanding finalizations.

  The Java Virtual Machine performs the finalization process automatically as needed if the `runFinalization` method is not invoked explicitly.

  See Also:
    finalize

traceInstructions

     public native void traceInstructions(boolean on)

  Enables/Disables tracing of instructions. If the `boolean` argument is `true`, this method asks the Java Virtual Machine to print out a detailed trace of each instruction in the Java Virtual Machine as it is executed. The virtual machine may ignore this request if it does not support this feature. The destination of the trace output is system dependent.

  If the `boolean` argument is `false`, this method causes the Java Virtual Machine to stop performing the detailed instruction trace it is performing.

  Parameters:
    on - `true` to enable instruction tracing; `false` to disable this feature.

traceMethodCalls

     public native void traceMethodCalls(boolean on)

  Enables/Disables tracing of method calls. If the `boolean` argument is `true`, this method asks the Java Virtual Machine to print out a detailed trace of each method in the Java Virtual Machine as it is called. The virtual machine may ignore this request if it does not support this feature. The destination of the trace output is system dependent.

  If the `boolean` argument is `false`, this method causes the Java Virtual Machine to stop performing the detailed method trace it is performing.

  Parameters:
    on - `true` to enable instruction tracing; `false` to disable this feature.

load

     public synchronized void load(String filename)

  Loads the specified filename as a dynamic library. The filename argument must be a complete pathname. From `java_g` it will automagically insert "_g" before the ".so" (for example `Runtime.getRuntime().load("/home/avh/lib/libX11.so");`).

  If there is a security manager, its `checkLink` method is called with the `filename` as its argument. This may result in a security exception.

  Parameters:
    filename - the file to load.
  Throws: SecurityException
    if the current thread cannot load the specified dynamic library.
  Throws: UnsatisfiedLinkError
    if the file does not exist.
  See Also:
    getRuntime, SecurityException, checkLink

loadLibrary

     public synchronized void loadLibrary(String libname)

  Loads the dynamic library with the specified library name. The mapping from a library name to a specific filename is done in a system-specific manner.

  First, if there is a security manager, its `checkLink` method is called with the `filename` as its argument. This may result in a security exception.

  If this method is called more than once with the same library name, the second and subsequent calls are ignored.

  Parameters:
    libname - the name of the library.
  Throws: SecurityException
    if the current thread cannot load the specified dynamic library.
  Throws: UnsatisfiedLinkError
    if the library does not exist.
  See Also:
    SecurityException, checkLink

getLocalizedInputStream

     public InputStream getLocalizedInputStream(InputStream in)

  Note: getLocalizedInputStream() is deprecated. As of JDK 1.1, the preferred way translate a byte stream in the local encoding into a character stream in Unicode is via the `InputStreamReader` and `BufferedReader` classes.

  Creates a localized version of an input stream. This method takes an `InputStream` and returns an `InputStream` equivalent to the argument in all respects except that it is localized: as characters in the local character set are read from the stream, they are automatically converted from the local character set to Unicode.

  If the argument is already a localized stream, it may be returned as the result.

  Returns:
    a localized input stream.
  See Also:
    InputStream, BufferedReader, InputStreamReader

getLocalizedOutputStream

     public OutputStream getLocalizedOutputStream(OutputStream out)

  Note: getLocalizedOutputStream() is deprecated. As of JDK 1.1, the preferred way to translate a Unicode character stream into a byte stream in the local encoding is via the `OutputStreamWriter`, `BufferedWriter`, and `PrintWriter` classes.

  Creates a localized version of an output stream. This method takes an `OutputStream` and returns an `OutputStream` equivalent to the argument in all respects except that it is localized: as Unicode characters are written to the stream, they are automatically converted to the local character set.

  If the argument is already a localized stream, it may be returned as the result.

  Returns:
    a localized output stream.
  See Also:
    OutputStream, BufferedWriter, OutputStreamWriter, PrintWriter

    All Packages  Class Hierarchy  This Package  Previous  Next  Index

Submit a bug or feature - Version 1.1.8 of Java Platform API Specification
Java is a trademark or registered trademark of Sun Microsystems, Inc. in the US and other countries.
Copyright 1995-1999 Sun Microsystems, Inc. 901 San Antonio Road,
Palo Alto, California, 94303, U.S.A. All Rights Reserved.